<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h2>#{messages['net.ihe.gazelle.atna.TLSSSLServerSimulator']}</h2>
        <ui:decorate template="/simulators/authenticateTestCommon.xhtml">
            <ui:param name="managerBean" value="#{authenticateServerTestManager}"/>

            <ui:define name="specificSimulatorPanel">
                <h:form id="serverForm">

                    <ui:decorate
                            template="#{s:hasRole('admin_role') ? '/layout/panels/_panel_title_footer.xhtml' : '/layout/panels/_panel_title.xhtml'}">
                        <ui:define name="panel_title">#{messages['net.ihe.gazelle.atna.NetworkParameters']}</ui:define>

                        <dl class="dl-horizontal">

                            <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                <ui:define name="label">#{messages['net.ihe.gazelle.atna.Status']}</ui:define>
                                <ui:param name="dd_styleClass" value="gzl-dd-label"/>
                                <h:outputText value="#{messages['net.ihe.gazelle.atna.Running']}"
                                              styleClass="gzl-label gzl-label-green"
                                              rendered="#{authenticateServerTestManager.selectedSimulator.isRunning() and authenticateServerTestManager.isForwardReachable()}"/>
                                <h:outputText value="#{messages['net.ihe.gazelle.atna.Error']}"
                                              styleClass="gzl-label gzl-label-orange"
                                              title="Forward service is not reachable"
                                              rendered="#{authenticateServerTestManager.selectedSimulator.isRunning() and not authenticateServerTestManager.isForwardReachable()}"/>
                                <h:outputText value="#{messages['net.ihe.gazelle.atna.Stopped']}"
                                              styleClass="gzl-label gzl-label-red"
                                              rendered="#{not authenticateServerTestManager.selectedSimulator.isRunning()}"/>
                            </ui:decorate>

                            <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                <ui:define name="label">#{messages['net.ihe.gazelle.atna.ServerType']}</ui:define>
                                <h:outputText value="#{authenticateServerTestManager.selectedSimulator.channelType}"/>
                            </ui:decorate>

                            <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                <ui:define name="label">#{messages['net.ihe.gazelle.atna.ServerIPHost']}</ui:define>
                                <h:outputText value="#{serverManager.getIps()}"/>
                            </ui:decorate>

                            <h:panelGroup rendered="#{not authenticateServerTestManager.isEditMode()}">

                                <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.ServerPort']}</ui:define>
                                    <h:outputText value="#{authenticateServerTestManager.selectedSimulator.localPort}"/>
                                </ui:decorate>

                                <h:panelGroup rendered="#{s:hasRole('admin_role')}">
                                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.ForwardTo']}
                                        </ui:define>
                                        <h:outputText
                                                value="#{authenticateServerTestManager.selectedSimulator.remoteHost}:#{authenticateServerTestManager.selectedSimulator.remotePort}"/>
                                        <s:span styleClass="gzl-icon-circle-green"
                                                rendered="#{authenticateServerTestManager.isForwardReachable()}"
                                                title="#{messages['net.ihe.gazelle.atna.ForwardReachable']}"></s:span>
                                        <s:span styleClass="gzl-icon-circle-red"
                                                rendered="#{not authenticateServerTestManager.isForwardReachable()}"
                                                title="#{messages['net.ihe.gazelle.atna.ForwardNotReachable']}"></s:span>
                                        <a4j:commandLink title="#{messages['net.ihe.gazelle.atna.RefreshForwardStatus']}"
                                                         action="#{authenticateServerTestManager.clearForwardCache()}"
                                                         execute="@this" render="serverForm">
                                            <span class="fa fa-refresh"></span>
                                        </a4j:commandLink>
                                    </ui:decorate>
                                </h:panelGroup>

                            </h:panelGroup>
                        </dl>

                        <h:panelGroup rendered="#{authenticateServerTestManager.isEditMode()}">
                            <div class="form-horizontal">

                                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                    <ui:param name="id" value="serverPortInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.ServerPort']}</ui:define>
                                    <rich:inputNumberSpinner id="serverPortInput" minValue="1025" maxValue="65536"
                                                             value="#{authenticateServerTestManager.selectedSimulator.localPort}"
                                                             required="true"/>
                                </s:decorate>

                                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                    <ui:param name="id" value="remoteHostInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.RemoteHost']}</ui:define>
                                    <h:inputText id="remoteHostInput" required="true" size="60"
                                                 value="#{authenticateServerTestManager.selectedSimulator.remoteHost}"
                                                 styleClass="form-control"/>
                                </s:decorate>

                                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                    <ui:param name="id" value="remotePortInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.RemotePort']}</ui:define>
                                    <rich:inputNumberSpinner id="remotePortInput" required="true"
                                                             value="#{authenticateServerTestManager.selectedSimulator.remotePort}"
                                                             minValue="1" maxValue="65536"/>
                                </s:decorate>

                            </div>
                        </h:panelGroup>

                        <ui:define name="panel_footer">
                            <h:panelGroup
                                    rendered="#{s:hasRole('admin_role') and not authenticateServerTestManager.isEditMode()}">
                                <a4j:commandButton value="#{messages['net.ihe.gazelle.atna.EditParameters']}"
                                                   action="#{authenticateServerTestManager.setEditMode(true)}"
                                                   execute="@this" styleClass="gzl-btn" render="serverForm"/>
                                <a4j:commandButton value="#{messages['net.ihe.gazelle.atna.StartServer']}"
                                                   action="#{authenticateServerTestManager.startServer()}"
                                                   rendered="#{(not authenticateServerTestManager.selectedSimulator.isRunning()) and authenticateServerTestManager.selectedSimulator.isEnabled()}"
                                                   execute="@this" render="serverForm"
                                                   styleClass="gzl-btn-green btn-xs"/>
                                <a4j:commandButton value="#{messages['net.ihe.gazelle.atna.StopServer']}"
                                                   action="#{authenticateServerTestManager.stopServer()}"
                                                   rendered="#{authenticateServerTestManager.selectedSimulator.isRunning()}"
                                                   execute="@this" render="serverForm"
                                                   styleClass="gzl-btn-red btn-xs"/>
                            </h:panelGroup>
                            <h:panelGroup
                                    rendered="#{s:hasRole('admin_role')  and authenticateServerTestManager.isEditMode()}">
                                <a4j:commandButton value="#{messages['net.ihe.gazelle.atna.Save']}"
                                                   action="#{authenticateServerTestManager.saveServer()}"
                                                   rendered="#{not authenticateServerTestManager.selectedSimulator.isRunning()}"
                                                   render="serverForm" styleClass="gzl-btn-blue"/>
                                <a4j:commandButton value="#{messages['net.ihe.gazelle.atna.SaveAndRestartServer']}"
                                                   action="#{authenticateServerTestManager.saveAndRestartServer()}"
                                                   rendered="#{authenticateServerTestManager.selectedSimulator.isEnabled()}"
                                                   render="serverForm" styleClass="gzl-btn-blue"/>
                                <a4j:commandButton value="#{messages['net.ihe.gazelle.atna.Cancel']}"
                                                   action="#{authenticateServerTestManager.cancelEdit()}"
                                                   render="serverForm" styleClass="gzl-btn"/>
                            </h:panelGroup>

                        </ui:define>
                    </ui:decorate>

                </h:form>
            </ui:define>

        </ui:decorate>
    </ui:define>
</ui:composition>
